echo off
cls

if not /%1==/ goto assemble

:use
rem 
rem Show this help message, if no filename is given to the batch file.
rem 
echo.
echo"     ͻ
echo"      ***********  ASSEMBLE THE FILE AND START THE PROGRAM  ************ 
echo"     Ķ
echo"      This batch file will assemble and link assembly language files.    
echo"                                                                         
echo"      If successfull, you can directly start the program from this batch.
echo"                                                                         
echo"      If there are errors while compiling, your source file and err.txt  
echo"      will be loaded into your editor (I use Q.EXE) for debugging.       
echo"      Perhaps you have to change the line to use your editor.            
echo"     ͼ
echo.
goto exit

:assemble
rem 
rem Assemble and link the source file and run the program.
rem 
pacc -q -2 -o -eerr.txt %1.as
if errorlevel==1 goto end
cls
if exist %1.exe %1
goto quit

:error
rem 
rem An error occured, so we have to look at the error file and the source.
rem 
q err.txt %1.as

:quit
rem 
rem At the end we clean up everthing.
rem 
if exist %1.obj del %1.obj > nul
if exist %1.exe del %1.exe > nul

:exit
rem 
rem Do nothing but deleting the error text file.
rem 
if exist err.txt del err.txt > nul

